----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:40:19 06/25/2006 
-- Design Name: 
-- Module Name:    top - IMP 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity top is
  generic (
    C_CNT_WIDTH : integer := 19
    );

    Port ( 
        SYS_CLK : in  STD_LOGIC;
        SYS_RST : in  STD_LOGIC;
        nLE : out  STD_LOGIC_VECTOR(0 to 3)
    );
end top;

architecture IMP of top is
signal count : STD_LOGIC_VECTOR(0 to C_CNT_WIDTH-1);
signal le : STD_LOGIC_VECTOR( 0 to 3);
    component slot_counter
        generic (
            C_CNT_WIDTH             : integer := C_CNT_WIDTH
        );
        port (
            SYS_CLK : in STD_LOGIC; 
            SYS_RST : in STD_LOGIC; 
            count : out STD_LOGIC_VECTOR(0 to C_CNT_WIDTH-1)
        );
    end component;

    component le_seq_blink
        port (
            SYS_CLK : in STD_LOGIC;
            SYS_RST : in STD_LOGIC;
						le_timing : in STD_LOGIC;
            le : out STD_LOGIC_VECTOR(0 to 3)
        );
    end component;

begin

    slot_counter_0 : slot_counter   
        Port map(
            SYS_CLK => SYS_CLK,     
            SYS_RST => SYS_RST,
            count => count
        );

    le_seq_blink_0 : le_seq_blink   
        Port map(
            SYS_CLK => SYS_CLK,     
            SYS_RST => SYS_RST,
						le_timing => count(0),
            le => le
        );
            
    nLE <= not le;

end IMP;

